/**********************************************************/
/* this file contains all functions to add help for the   */
/* new commands                                           */
/**********************************************************/
#include "help.h"

/***********************************************************/
/* adding help for /nickserv help set alogin               */
/***********************************************************/
int ns_help_set_alogin(User *u) {
    noticeLang(s_NickServ, u, ALOGIN_SYNTAX, s_NickServ);
    noticeLang(s_NickServ, u, ALOGIN_HELP, s_NickServ);
    return MOD_CONT;
}
/***********************************************************/
/* adding help for /nickserv help set ajoin                */
/***********************************************************/

int ns_help_set_ajoin(User *u) {
    noticeLang(s_NickServ, u, AJOIN_SYNTAX, s_NickServ);
    noticeLang(s_NickServ, u, AJOIN_HELP, s_NickServ);
    return MOD_CONT;
}
/***********************************************************/
/* adding help for /nickserv help set realname             */
/***********************************************************/

int ns_help_set_realname(User *u) {
    noticeLang(s_NickServ, u, REALNAME_SYNTAX, s_NickServ );
    noticeLang(s_NickServ, u, REALNAME_HELP, s_NickServ);
    return MOD_CONT;
}
/***********************************************************/
/* adding help for /nickserv help set vhost                */
/***********************************************************/

int ns_help_set_vhost(User *u) {
    noticeLang(s_NickServ, u, VHOST_NS_SYNTAX, s_NickServ);
    noticeLang(s_NickServ, u, VHOST_NS_HELP, s_NickServ);
    return MOD_CONT;
}
/***********************************************************/
/* adding help for /operserv help swhois                   */
/***********************************************************/

int os_help_swhois(User *u) {
    noticeLang(s_OperServ, u, SWHOIS_SYNTAX, s_OperServ);
    noticeLang(s_OperServ, u, SWHOIS_HELP, s_OperServ);
    return MOD_CONT;
}
/***********************************************************/
/* adding help for /operserv help helpop                   */
/***********************************************************/

int os_help_helpop(User *u) {
    noticeLang(s_OperServ, u, HELPOP_SYNTAX, s_OperServ);
    noticeLang(s_OperServ, u, HELPOP_HELP, s_OperServ);
    return MOD_CONT;
}
/***********************************************************/
/* adding help for /operserv help snomask                  */
/***********************************************************/

int os_help_snomask(User *u) {
    noticeLang(s_OperServ, u, SNOMASK_SYNTAX, s_OperServ);
    noticeLang(s_OperServ, u, SNOMASK_HELP, s_OperServ);
    return MOD_CONT;
}
/***********************************************************/
/* adding help for /operserv help vhost                    */
/***********************************************************/

int os_help_vhost(User *u) {
    noticeLang(s_OperServ, u, VHOST_OS_SYNTAX, s_OperServ);
    noticeLang(s_OperServ, u, VHOST_OS_HELP, s_OperServ);
    return MOD_CONT;
}
/***********************************************************/
/* adding help for /operserv pending                       */
/***********************************************************/

int os_help_vhost_pending(User *u) {
    noticeLang(s_OperServ, u, VHOST_OS_PEN_SYNTAX, s_OperServ);
    noticeLang(s_OperServ, u, VHOST_OS_PEN_HELP, s_OperServ);
    return MOD_CONT;
}

/***********************************************************/
/* adding some additional lines to /operserv help          */
/***********************************************************/


void help_operserv(User *u) {
#ifdef USE_VHOSTREQ
    if (ircd->vhost) {
        noticeLang(s_OperServ, u, OS_HELPLINE_VHOST, s_OperServ);
    }
#endif /* USE_VHOSTREQ */
#ifdef USE_SWHOIS
        noticeLang(s_OperServ, u, OS_HELPLINE_SWHOIS, s_OperServ);
#endif /* USE_SWHOIS */
#ifdef USE_HELPOP
        noticeLang(s_OperServ, u, OS_HELPLINE_HELPOP, s_OperServ);
#endif /* USE_HELPOP */
#ifdef USE_SNOMASK
        noticeLang(s_OperServ, u, OS_HELPLINE_SNOMASK, s_OperServ);
#endif /* USE_SNOMASK */
}

/***********************************************************/
/* adding some additional lines to /nickserv help set      */
/***********************************************************/

int ns_help_set(User *u) {
    char *temp = moduleGetLastBuffer();
    char *option = myStrGetTokenRemainder(temp,' ',0);

    if (option && stricmp(option, "SET")==0) {
        noticeLang(s_NickServ, u, HELPLINE_ADDITIONAL, s_NickServ);
        noticeLang(s_NickServ, u, NS_HELPLINE_SET_ALOGIN, s_NickServ);
#ifdef USE_VHOSTREQ
        if (ircd->vhost) {
            noticeLang(s_NickServ, u, NS_HELPLINE_SET_VHOST, s_NickServ);
        }
#endif
#ifdef USE_AJOIN
            noticeLang(s_NickServ, u, NS_HELPLINE_SET_AJOIN, s_NickServ);
#endif
#ifdef USE_REALNAME
        if (ircd->chgreal) {
            noticeLang(s_NickServ, u, NS_HELPLINE_SET_REALNAME, s_NickServ);
        }
#endif

    }
    if (option) free(option); 
    return MOD_CONT;
}

