/**
 * Language variables and headers for filling
 *
 ***********
 * Module Name    : addon
 * Author         : Jens 'DukePyrolator' Voss <DukePyrolator@FantasyIRC.net>
 * Creation Date  : 21/07/2006
 *
 * based on bs_fantasy_ext by Viper <Viper@Anope.org>
 *
 * More info on http://modules.anope.org and http://forum.anope.org
 ***********
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 ***********
 *
 * Last Updated   : 27/12/2008
 *
 **/

#define getstring(na,index) \
	(langtexts[((na)&&((NickAlias*)na)->nc&&!(((NickAlias*)na)->status & NS_VERBOTEN)?((NickAlias*)na)->nc->language:NSDefLanguage)][(index)])


/*** Language Configuration Block ***/
/* Directory where we store our lang data..*/
#define LANG_SUBDIR_NAME			"addon"
 
/* Number of languages the mod is available in */
#define MOD_NUM_LANGS				1

/* Hardcoded default language. */
#define MOD_DEF_LANG				LANG_EN_US

/*** End Of Language Configuration Block ***/


/* Variables */
/* The list of lists of messages. */
char **modlangtexts[NUM_LANGS];

/* The list of names of languages. */
char *modlangnames[NUM_LANGS];

/* Indexes of available languages: */
int modlanglist[MOD_NUM_LANGS];

/* Store the default language used by the module */
int ModDefLanguage;

/* Index of languages supported by this module. */
int modlanglist[MOD_NUM_LANGS] = {
    LANG_EN_US,                 /* English (US) */
};

/* ------------------------------------------------------------------------------- */

void mod_lang_init();
void mod_lang_unload();
int mod_read_int32(int32 * ptr, FILE * f);
void mod_load_lang(int index, const char *filename);
void mod_lang_sanitize();
char *getLangString(User *u, int message);
void noticeLang(char *source, User * dest, int message, ...);

/* ------------------------------------------------------------------------------- */

/* Language Variables */

/* EOF */
