#include "swhois.h"

/* swhois */

int os_swhois(User *u) {
    char *temp = moduleGetLastBuffer();
    char *cmd = myStrGetToken(temp,' ',0);
    char *option1 = myStrGetToken(temp,' ',1);
    char *option2 = myStrGetTokenRemainder(temp,' ',2);
    NickAlias *target;
    int i = 1;

    if (!cmd) {
        noticeLang(s_OperServ, u, SWHOIS_SYNTAX);
        goto MODSTOP;
    }
    if (stricmp(cmd, "ADD")==0) {  /* add a new swhois */
        if (!option1 || !option2) {
            noticeLang(s_OperServ, u, SWHOIS_SYNTAX);
            goto MODSTOP;
        }
        target = findnick(option1);
        if (!target) {
            noticeLang(s_OperServ, u, NOTICE_NO_REGISTERED_NICK, option1);
            goto MODSTOP;
        }
        if (strlen(option2) > 280) {
            noticeLang(s_OperServ, u, SWHOIS_NOTICE_TOO_LONG);
            goto MODSTOP;
        }
        add_to_db(target, "swhois", option2);
        add_to_db(target, "s_setter", u->na->nc->display); /* stores the nickgroup of the user, who added or modified the entry */
        noticeLang(s_OperServ, u, SWHOIS_NOTICE_ADDED_TO_LIST, option1);
        if (finduser(option1)) { /* if user is online, set the new swhois */
            anope_cmd_swhois(s_NickServ, option1, option2);
        }
        goto MODSTOP;
    }
    if (stricmp(cmd, "DEL")==0) { /* delete a swhois */
        if (!option1) {
            noticeLang(s_OperServ, u, SWHOIS_SYNTAX);
            goto MODSTOP;
        }
        target = findnick(option1);
        if (!target) {
            noticeLang(s_OperServ, u, NOTICE_NO_REGISTERED_NICK, option1);
            goto MODSTOP;
        }
        get_from_db(target->nick, "swhois");
        if (!myresult || stricmp(myresult, "")==0) {
            noticeLang(s_OperServ, u, SWHOIS_NOTICE_NOT_IN_LIST, option1);
            goto MODSTOP;
        }
        add_to_db(target, "swhois", "");
        add_to_db(target, "s_setter", u->na->nc->display);  /* stores the nickgroup of the user, who deleted the entry */
        noticeLang(s_OperServ, u, SWHOIS_NOTICE_REMOVED_FROM_LIST, option1);
        anope_cmd_swhois(s_NickServ, option1," "); /* delete swhois */
        goto MODSTOP;
    }
    if (stricmp(cmd, "LIST")==0) {
        if (option1) {
            do_query( "SELECT nick, swhois, s_setter FROM " DBNAME " ",
                      "WHERE swhois IS NOT NULL ",
                      "AND ( nick LIKE '%%%s%%' OR swhois LIKE '%%%s%%' OR s_setter LIKE '%%%s%%') ",
                      "ORDER by nick;",option1, option1, option1);
        } else {
            do_query( "SELECT nick, swhois, s_setter FROM " DBNAME " "
                      "WHERE swhois IS NOT NULL ORDER by nick;");
        }
        myres = mysql_store_result(mymysql);
        if (mysql_num_rows(myres) > 0) {
            while ((myrow = mysql_fetch_row(myres)) != NULL) {
                notice_user(s_OperServ, u,"#%2i Nick: \002%-16s\002 swhois: \002%-35s\002 (%s)",
                            i, myrow[0] ? myrow[0] : "NULL" ,
                            myrow[1] ? myrow[1] : "NULL" ,
                            myrow[2] ? myrow[2] :"NULL" );
                i++;
            }
            mysql_free_result(myres);
            goto MODSTOP;
        }
        noticeLang(s_OperServ, u, NOTICE_EMPTY_LIST);
        mysql_free_result(myres); /* free unused memory */
        goto MODSTOP;
    }
    noticeLang(s_OperServ, u, SWHOIS_SYNTAX);

    MODSTOP:
        if (cmd) free(cmd);
        if (option1) free(option1);
        if (option2) free(option2);
        return MOD_STOP;
}

