#include "vhost.h"

/* vhost */

int os_vhost(User *u) {
    char *temp = moduleGetLastBuffer();
    char *cmd = myStrGetToken(temp,' ',0);
    char *option1 = myStrGetToken(temp,' ',1);
    char *option2 = myStrGetTokenRemainder(temp,' ',2);
    User *u2;
    NickAlias *target;
    int i = 1;

    if (!cmd) {
	noticeLang(s_OperServ, u, VHOST_OS_SYNTAX);
	noticeLang(s_OperServ, u, VHOST_OS_SYNTAX_MORE);
	goto MODSTOP;
    }
    if (stricmp(cmd, "ADD")==0) {
	if (!option1 || !option2) {
	    noticeLang(s_OperServ, u, VHOST_OS_SYNTAX);
	    noticeLang(s_OperServ, u, VHOST_OS_SYNTAX_MORE);
	    goto MODSTOP;
	}
	target = findnick(option1);
	if (!target) {
	    noticeLang(s_OperServ, u, NOTICE_NO_REGISTERED_NICK, option1);
	    goto MODSTOP;
	}
	if (!is_valid_vhost(u,option2)) { 
            goto MODSTOP; 
        }
	add_to_db(target, "vhost", option2);
	add_to_db(target, "vhoststatus", "1");
	add_to_db(target, "v_setter", u->na->nc->display);
	if ((u2 = finduser(option1))) {  /* send notice if nick is online */
	    noticeLang(s_NickServ, u2 , VHOST_NOTICE_NEW_VHOST);
	    add_to_db(target, "vhostreqstatus", "0");
	} else {                 /* send notice on next identify */
	    add_to_db(target, "vhostreqstatus", "4");
	}
	noticeLang(s_OperServ, u, VHOST_OS_NOTICE_ADDED_TO_LIST, option1);
	goto MODSTOP;
    }	
    if (stricmp(cmd, "DEL")==0) {
	if (!option1) {
	    noticeLang(s_OperServ, u, VHOST_OS_SYNTAX);
	    noticeLang(s_OperServ, u, VHOST_OS_SYNTAX_MORE);
            goto MODSTOP;
	}
        target = findnick(option1);
        if (!target) {
            noticeLang(s_OperServ, u, NOTICE_NO_REGISTERED_NICK, option1);
            goto MODSTOP;
        }
	get_from_db(target->nick, "vhost");
        if (!myresult ) {
	    noticeLang(s_OperServ, u, VHOST_OS_NOTICE_NOT_IN_LIST, option1);
	    goto MODSTOP;
	}
	add_to_db(target, "vhoststatus", "0");
	add_to_db(target, "vhost", "");
	add_to_db(target, "v_setter", u->na->nc->display);  /* stores the nickgroup of the user, who deleted the entry */
	if ((u2 = finduser(option1))) {  /* send notice if nick is online */
	    noticeLang(s_NickServ, u2, VHOST_NOTICE_DEL_VHOST);
	    add_to_db(target, "vhostreqstatus", "0");
	} else {                 /* send notice von next identify */
	    add_to_db(target, "vhostreqstatus", "5");
	}
	noticeLang(s_OperServ, u, VHOST_OS_NOTICE_REMOVED_FROM_LIST, option1);
	goto MODSTOP;
    }    
    if (stricmp(cmd, "LIST")==0) {
	if (option1) {
	    do_query("SELECT nick, vhost, v_setter FROM " DBNAME " "
		    "WHERE vhost IS NOT NULL "
		    "AND ( nick LIKE '%%%s%%' OR vhost LIKE '%%%s%%' OR v_setter LIKE '%%%s%%') "
	            "ORDER by `nick`;",option1, option1, option1);	
	} else {
	    do_query("SELECT nick, vhost, v_setter FROM " DBNAME " "
	    	    "WHERE vhost IS NOT NULL ORDER by nick;");
	}
        myres = mysql_store_result(mymysql);
	if (mysql_num_rows(myres) > 0) {	
	    while ((myrow = mysql_fetch_row(myres)) != NULL) {
		notice_user(s_OperServ, u,"#%2i Nick: \002%-16s\002 vhost: \002%-35s\002 (%s)",i, 
                            myrow[0] ? myrow[0] : "NULL" ,
                            myrow[1] ? myrow[1] : "NULL" ,
                            myrow[2] ? myrow[2] : "NULL" );
    		i++;
	    }
	    mysql_free_result(myres);
	    goto MODSTOP;
	}
	noticeLang(s_OperServ, u, NOTICE_EMPTY_LIST);
	mysql_free_result(myres); /* free unused memory */
	goto MODSTOP;
    }
    if (stricmp(cmd, "PENDING")==0) {  /* list, ack, del, ackall */
	if (!option1) {
	    noticeLang(s_OperServ, u, VHOST_OS_PEN_SYNTAX);
	    noticeLang(s_OperServ, u, VHOST_OS_PEN_SYNTAX_MORE);
	    goto MODSTOP;
	}
        if (stricmp(option1, "LIST")==0) { 
	    do_query("SELECT nick, vhostreq FROM " DBNAME " "
		    "WHERE vhostreqstatus = '1' "
		    "AND vhostreq IS NOT NULL ORDER by nick;");
	    myres = mysql_store_result(mymysql);
            if (mysql_num_rows(myres) > 0) {
        	while ((myrow = mysql_fetch_row(myres)) != NULL) {
            	    notice_user(s_OperServ, u,"#%2i Nick: \002%-16s\002 vhost: \002%-35s\002",i, 
                        myrow[0] ? myrow[0] : "NULL" , 
                        myrow[1] ? myrow[1] : "NULL" );
            	    i++;
	        }
		mysql_free_result(myres);
		goto MODSTOP;
	    }
	    noticeLang(s_OperServ, u, NOTICE_EMPTY_LIST);
	    mysql_free_result(myres); /* free unused memory */
	    goto MODSTOP;
	}
	if (stricmp(option1, "ACKALL")==0) {
            do_query("SELECT nick, vhostreq FROM " DBNAME " "
                    "WHERE vhostreqstatus = '1' "
                    "AND vhostreq IS NOT NULL;");
	    myres = mysql_store_result(mymysql);
    	    if (mysql_num_rows(myres) > 0) {
                while ((myrow = mysql_fetch_row(myres)) != NULL) {
		    if ((u2 = finduser(myrow[0]))) { /* send notice if nick is online */
			noticeLang(s_NickServ, u2, VHOST_NOTICE_ACCEPT);
			qbuf1 = quote(myrow[1]);
			qbuf2 = quote(u->na->nc->display);
			qbuf3 = quote(myrow[0]);
			do_query("UPDATE " DBNAME " "
                                "SET vhost='%s', vhoststatus='1', "
                                "vhostreq = NULL, vhostreqstatus = '0', "
			        "v_setter = '%s' " 
                                "WHERE nick= '%s';", qbuf1, qbuf2, qbuf3);
			free(qbuf1); free(qbuf2); free(qbuf3);
		    } else { /* update and send notice on next identify */
                        qbuf1 = quote(myrow[1]);
                        qbuf2 = quote(u->na->nc->display);
                        qbuf3 = quote(myrow[0]);
			do_query("UPDATE " DBNAME " "
			    	"SET vhost='%s', vhoststatus='1', "
				"vhostreq = NULL, vhostreqstatus = '2', "
				"v_setter = '%s' "
				"WHERE nick ='%s';", qbuf1, qbuf2, qbuf3);
			free(qbuf1); free(qbuf2); free(qbuf3);
		    }
		}
		noticeLang(s_OperServ, u, VHOST_OS_NOTICE_PEN_ACKALL);
	    } else {
		noticeLang(s_OperServ, u, NOTICE_EMPTY_LIST);
	    }
	    mysql_free_result(myres); /* free unused memory */
	    goto MODSTOP;
	}
	if (stricmp(option1, "ACK")==0) {
	    if (!option2) {
		noticeLang(s_OperServ, u, VHOST_OS_PEN_SYNTAX);
		noticeLang(s_OperServ, u, VHOST_OS_PEN_SYNTAX_MORE);
		goto MODSTOP;
	    }
    	    target = findnick(option2);
    	    if (!target) {
        	noticeLang(s_OperServ, u, NOTICE_NO_REGISTERED_NICK, option2);
        	goto MODSTOP;
    	    }
	    get_from_db(option2, "vhostreqstatus");
	    if (!(stricmp(myresult,"1")==0)) {
		noticeLang(s_OperServ, u, VHOST_OS_PEN_NOTICE_NOT_IN_LIST, option2);
		goto MODSTOP;
	    }
	    get_from_db(option2, "vhostreq");
	    qbuf3 = quote(myresult);
	    add_to_db(target, "vhost", qbuf3);
	    free(qbuf3);
	    add_to_db(target, "vhoststatus", "1");
	    add_to_db(target, "vhostreq", "");
	    add_to_db(target, "v_setter", u->na->nc->display);
    	    if ((u2 = finduser(option2))) {  /* send notice if nick is online */
        	noticeLang(s_NickServ, u2, VHOST_NOTICE_ACCEPT);
        	add_to_db(target, "vhostreqstatus", "0");
    	    } else {                 /* send notice von next identify */
        	add_to_db(target, "vhostreqstatus", "2");
	    }
	    noticeLang(s_OperServ, u, VHOST_OS_NOTICE_PEN_ACK, option2);
	    goto MODSTOP;
	} 
	if (stricmp(option1, "DEL")==0) {
            if (!option2) {
                noticeLang(s_OperServ, u, VHOST_OS_PEN_SYNTAX);
                noticeLang(s_OperServ, u, VHOST_OS_PEN_SYNTAX_MORE);
                goto MODSTOP;
            }
            target = findnick(option2);
            if (!target) {
                noticeLang(s_OperServ, u, NOTICE_NO_REGISTERED_NICK, option1);
                goto MODSTOP;
            }
            get_from_db(option2, "vhostreqstatus");
            if (!myresult || !(stricmp(myresult,"1")==0)) {
                noticeLang(s_OperServ, u, VHOST_OS_PEN_NOTICE_NOT_IN_LIST, option2);
                goto MODSTOP;
            }
	    add_to_db(target, "vhostreq", "");
            if ((u2 = finduser(option2))) {  /* send notice if nick is online */
                noticeLang(s_NickServ, u2, VHOST_NOTICE_REJECT);
                add_to_db(target, "vhostreqstatus", "0");
            } else {                 /* send notice von next identify */
                add_to_db(target, "vhostreqstatus", "3");
            }
	    noticeLang(s_OperServ, u, VHOST_OS_NOTICE_PEN_REJECT, option2);
	    goto MODSTOP;
	}
    }
    noticeLang(s_OperServ, u, VHOST_OS_SYNTAX);
    noticeLang(s_OperServ, u, VHOST_OS_SYNTAX_MORE);


    MODSTOP:
	if (cmd) free(cmd);
	if (option1) free(option1);
	if (option2) free(option2);
	return MOD_STOP;

}

/***************************************************************************************************/

int my_isvalidchar(const char c)
{
    if(isalnum(c)||(c=='.')||(c=='-')){return 1;}else{return 0;}
}

/****************************************************************************************************/
/* sets a vhost and vident to a user                                                                */
/* input:       u = pointer to userstruct                                                           */
/*              vhoststring = pointer to vhost ( user@mydomain.com )                                */
/*              the vhoststring should already be checked with is_valid_vhost()                     */
/* output:      always 1                                                                            */
/****************************************************************************************************/

int set_vhost(User *u, char *vhoststring) {
    char *vIdent = NULL;
    char *hostmask = NULL;

    if (strchr(vhoststring,'@')) {
        vIdent = myStrGetOnlyToken(vhoststring,'@',0);
        if (vIdent) {
            if(strlen(vIdent) > 0) {
                if (u->vident) free(u->vident);
                u->vident = sstrdup(vIdent);
            }
        }
        hostmask = myStrGetTokenRemainder(vhoststring,'@',1);
        if (hostmask) {
            if (u->vhost) free(u->vhost);
            u->vhost = sstrdup(hostmask);
        }
    } else {
        if (u->vhost) free(u->vhost);
        u->vhost = sstrdup(vhoststring);
    }
    anope_cmd_vhost_on(u->nick, u->vident, u->vhost);
    if (vIdent) free(vIdent);
    if (hostmask) free(hostmask);
    return MOD_CONT;
}

/****************************************************************************************************/
/* checks if a vhost is valid                                                                       */
/* input        u = pointer to userstruct (needed for notice_lang)                                  */
/*              rawhostmask = pointer to a string with a hostmask ( user@mydomain.com )             */
/* return       1 if vhost is valid                                                                 */
/*              0 if vhost is not valid                                                             */
/****************************************************************************************************/

int is_valid_vhost(User *u, char *rawhostmask) {
    char *vIdent = NULL;
    char *s;
    char *hostmask = malloc(HOSTMAX);

        vIdent = myStrGetOnlyToken(rawhostmask,'@',0);
        if (vIdent) {
            rawhostmask = myStrGetTokenRemainder(rawhostmask,'@',1);
            if (!rawhostmask) {
                noticeLang(s_NickServ, u, VHOST_NS_SYNTAX);
                goto MODSTOP;
            }
            if (strlen(vIdent) > USERMAX - 1) {
                notice_lang(s_NickServ, u, HOST_SET_IDENTTOOLONG, USERMAX);
                goto MODSTOP;
            } else {
                for (s = vIdent; *s; s++) {
                    if (!my_isvalidchar(*s)) {
                        notice_lang(s_NickServ, u, HOST_SET_IDENT_ERROR);
                        goto MODSTOP;
                    }
                }
            }
        }
        if (strlen(rawhostmask) < HOSTMAX - 1) {
            snprintf(hostmask, HOSTMAX - 1, "%s", rawhostmask);
        } else {
            notice_lang(s_NickServ, u, HOST_SET_TOOLONG, HOSTMAX);
            goto MODSTOP;
        }
        if (!isValidHost(hostmask, 3)) {
            notice_lang(s_NickServ, u, HOST_SET_ERROR);
            goto MODSTOP;
        }
    /* host is valid, return true */
        if (vIdent) free(vIdent);
        if (hostmask) free(hostmask);
        return 1;
 
    /* its not a valid host, return false */
    MODSTOP:
        if (vIdent) free(vIdent);
        if (hostmask) free(hostmask);
        return 0;
        
}

